import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Pacman
 * 
 * Johnathan
 * (-1.8)
 * 
 */
public class Pacman extends Actor
{   
    public static final int LEFT = 0;
    public static final int RIGHT = 1;
    public static final int UP = 2;
    public static final int DOWN = 3;

    private int direction;
    public static int dotsEaten;
    

    public Pacman()
    {
        //set direction to the right at start
        direction = RIGHT;
    }
    
    public void act()
    //sal;dkfj;sdlakjfsaifgowae
    {
              // die
            if(foundnublet()) {
            Greenfoot.stop();
            getWorld().addObject(new youlose(), 250, 350);
            GreenfootSound sound=new GreenfootSound ("you lose.mp3");
            sound.play();
        }
               // if dot is there eats it
        if(foundDot()) {
            munchies();
            return;
        }

        // Process keys (to change direction)
        // if can move, move in direction last facing
        if(canmove()) {
            move(+50);
            setImage("pacman closed.png");
            Greenfoot.delay (5);
            setImage("pacman open.png");
        }
        
        // key inputs to change direction
        if (Greenfoot.isKeyDown("left")) {
            setDirection(LEFT);
        }
        else if (Greenfoot.isKeyDown("right")) {
            setDirection(RIGHT);
        }
        else if (Greenfoot.isKeyDown("up")) {
            setDirection(UP);
        }
        else if (Greenfoot.isKeyDown("down")) {
            setDirection(DOWN);
        }  
        //if the pacman has et everything, display "youwin" and play pacman theme repeatedly
        if(winstuff() == true) {
            Greenfoot.stop();
            getWorld().addObject(new youwin(), 250, 350);
            GreenfootSound sound=new GreenfootSound ("song.mp3");
            sound.play();
        }

    }

    public boolean canmove()
    {

        // Find the x,y offset to look at
        int dx = 0;
        int dy = 0;

        switch (direction) {
            case UP: dy = -50;  break;
            case DOWN: dy = 50; break;
            case LEFT: dx = -50; break;
            case RIGHT: dx =  50; break;
        }
        // Find out if we're pointing into a wall

        Actor mayBeAWall = getOneObjectAtOffset(dx, dy, Actor.class);
        if(mayBeAWall != null && mayBeAWall instanceof wall) {
            System.out.println("blocked" + dx + " " + dy);
            return false;
        }
        else return true;
    }
    public void die()
    {
        if(foundnublet()) {
            Greenfoot.stop();
            getWorld().addObject(new youlose(), 250, 350);
            GreenfootSound sound=new GreenfootSound ("Reflections.mp3");
            sound.play();
        }
    }
    public boolean foundDot()
    {
        //find out if pacman is on a dot
        Actor dot = getOneObjectAtOffset(0, 0, dot.class);
        if(dot != null) {
            return true;
        }
        else {
            return false;
        }
    }
    public boolean foundnublet()
    {
        //find out if pacman is on a ghost
        Actor ghosty = getOneObjectAtOffset(0, 0, ghosty.class);
        if(ghosty != null) {
            return true;
        }
        else {
            return false;
        }
    }
    public void munchies()
    {
        //eat the aformentioned dot
        Actor dot = getOneObjectAtOffset(0, 0, dot.class);
        if(dot != null) {
            getWorld().removeObject(dot);
            dotsEaten = dotsEaten + 1; 
            Greenfoot.playSound("waka.mp3");
        }   

    }

    public static int getdotsEaten()
    {
        //find out how many dots the pacman has eaten during the game
        return dotsEaten;
    }

    public static boolean winstuff() {
        //if the pacman has eaten all of the available dots on the field, let the pacman know
        if(getdotsEaten()==64){
            return true;
        }
        return false;
    }

    public void setDirection(int direction)
    {
        //describes direction because pacman is a bit thick...
        this.direction = direction;
        switch(direction) {
            case DOWN :
            setRotation(90);
            break;
            case LEFT :
            setRotation(180);
            break;
            case UP :
            setRotation(270);
            break;
            case RIGHT :
            setRotation(0);
            break;
            default :
            break;
        }
    }
}